00100	;Carrier detect program, version 1.0
00200	;For 48k TRS-80 Model III, LDOS 5.1.3 and 5.1.4
00300	;Model I users: change addresses as noted in comments.
00400	;Written by Phillip Wherry, November 9, 1983
00500	;Copyright (c) 1983 Phillip Wherry.  Reproduction rights are granted
00600	;for non-commercial purposes (i.e. you cannot charge someone for a copy
00700	;of this program).  Please keep me informed of any changes or
00800	;improvements you have made or would like to see in the code.
00900	;
01000	;Phillip Wherry [70007,567]
01100	;
01200		ORG	5600H		;transient program area
01300	INIT	LD	A,0		;define task number 0
01400		LD	DE,TCB		;point to task control block
01500		CALL	403DH		;start task [Model I: CALL 4410H]
01600		LD	HL,MSG		;point to initialization message
01700		CALL	4467H		;display message
01800		JP	402DH		;jump to LDOS Ready
01900	MSG	DEFM	'Carrier detect driver, revision 1.0'
02000		DEFB	0AH
02100		DEFM	0DH
02200	TCB	DEFW	START		;point to start address
02300	START	RET			;zero this byte to enable detection
02400		PUSH	AF		;save registers
02500		IN	A,(232)		;get RS232 status
02600		AND	20H		;mask carrier detect bit
02700		OR	A		;transfer to flag register
02800		JP	NZ,STOP		;if no carrier, take action
02900		POP	AF		;carrier is ok, restore processor regs.
03000		RET			;return to foreground process
03100	STOP	LD	A,0		;task number
03200		CALL	4040H		;remove task [Model I: CALL 4413H]
03300		LD	A,2		;used for specialized hardware config.
03400		DEFW	0000H		;two NOPS, used to replace data for
03500		LD	BC,0		;specialized hardware.  Do not change
03600		CALL	0060H		;if you want to use addresses in docs.
03700		LD	BC,0		;Delay count value
03800		CALL	0060H		;delay one second.
03900		LD	A,0		;specialized hardware control
04000		DEFW	0000H		;NOPS to replace hardware controller
04100		LD	HL,RST		;point to restart command
04200		JP	4299H		;execute restart [Model I:CALL 4405H]
04300	RST	DEFM	'LBASIC RUN"LOGIN/BAS"'
04400		DEFB	0DH		;carriage return for restart command
04500		END	INIT		;start program at init address
